/*=============================================================================
Stuff
=============================================================================*/

#ifndef _INC_XC_COREGLOBALS
#define _INC_XC_COREGLOBALS

XC_CORE_API extern FMemStack		GXCMem; //For XC_Engine/Commandlet usage only
XC_CORE_API extern FFileManager*	GXFileManager;



XC_CORE_API void XCCNatives( UBOOL bEnable); //Enables the commented out opcodes in XC_CoreStatics, careful when using this online

XC_CORE_API void InitXCGlobals();
XC_CORE_API void DeInitXCGlobals();

XC_CORE_API void FixFilename( const TCHAR* Filename ); //Fixes platform specific paths, automatically sets up Linux file manager (GXFileManager)

XC_CORE_API UFunction* FindBaseFunction( UStruct* InStruct, const TCHAR* FuncName);
XC_CORE_API UProperty* FindScriptVariable( UStruct* InStruct, const TCHAR* PropName, INT* Found);

XC_CORE_API void SortStringsA( TArray<FString>* List);
XC_CORE_API void SortStringsSA( FString* List, INT ArrayMax);

XC_CORE_API void ThreadedLog( EName InName, const TCHAR* InStrLog); //Use this from a worker thread
XC_CORE_API void ThreadedLogFlush(); //Use this from main thread to print other threads' logs

#endif

/*-----------------------------------------------------------------------------
	The End.
-----------------------------------------------------------------------------*/
